diff --git a/python/mozbuild/mozbuild/action/test_archive.py b/python/mozbuild/mozbuild/action/test_archive.py
index 8ec4dd2a90..1ec7d12743 100644
--- a/python/mozbuild/mozbuild/action/test_archive.py
+++ b/python/mozbuild/mozbuild/action/test_archive.py
@@ -8,8 +8,8 @@
 # It is defined inline because this was easiest to make test archive
 # generation faster.
 
-from __future__ import absolute_import, print_function, unicode_literals
 
+from __future__ import print_function
 import argparse
 import itertools
 import os
@@ -200,10 +200,10 @@ ARCHIVE_FILES = {
             'source': buildconfig.topobjdir,
             'base': 'dist/bin',
             'patterns': [
-                '%s%s' % (f, buildconfig.substs['BIN_SUFFIX'])
+                '{}{}'.format(f, buildconfig.substs['BIN_SUFFIX'])
                 for f in TEST_HARNESS_BINS
             ] + [
-                '%s%s%s' % (buildconfig.substs['DLL_PREFIX'], f, buildconfig.substs['DLL_SUFFIX'])
+                '{}{}{}'.format(buildconfig.substs['DLL_PREFIX'], f, buildconfig.substs['DLL_SUFFIX'])
                 for f in TEST_HARNESS_DLLS
             ],
             'dest': 'bin',
@@ -212,7 +212,7 @@ ARCHIVE_FILES = {
             'source': buildconfig.topobjdir,
             'base': 'dist/plugins',
             'patterns': [
-                '%s%s%s' % (buildconfig.substs['DLL_PREFIX'], f, buildconfig.substs['DLL_SUFFIX'])
+                '{}{}{}'.format(buildconfig.substs['DLL_PREFIX'], f, buildconfig.substs['DLL_SUFFIX'])
                 for f in TEST_PLUGIN_DLLS
             ],
             'dest': 'bin/plugins',
@@ -499,7 +499,7 @@ def find_manifest_dirs(topsrcdir, manifests):
         if p.endswith('.ini'):
             test_manifest = TestManifest()
             test_manifest.read(p)
-            dirs |= set([os.path.dirname(m) for m in test_manifest.manifests()])
+            dirs |= {os.path.dirname(m) for m in test_manifest.manifests()}
 
         elif p.endswith('.list'):
             m = ReftestManifest()
@@ -557,8 +557,8 @@ def main(argv):
     duration = time.time() - t_start
     zip_size = os.path.getsize(args.outputfile)
     basename = os.path.basename(args.outputfile)
-    print('Wrote %d files in %d bytes to %s in %.2fs' % (
-          file_count, zip_size, basename, duration))
+    print(('Wrote %d files in %d bytes to %s in %.2fs' % (
+          file_count, zip_size, basename, duration)))
 
 
 if __name__ == '__main__':
diff --git a/python/mozbuild/mozbuild/action/webidl.py b/python/mozbuild/mozbuild/action/webidl.py
index d595c728ec..a8cd3aea96 100644
--- a/python/mozbuild/mozbuild/action/webidl.py
+++ b/python/mozbuild/mozbuild/action/webidl.py
@@ -2,7 +2,6 @@
 # License, v. 2.0. If a copy of the MPL was not distributed with this
 # file, You can obtain one at http://mozilla.org/MPL/2.0/.
 
-from __future__ import absolute_import
 
 import sys
 
diff --git a/python/mozbuild/mozbuild/action/xpccheck.py b/python/mozbuild/mozbuild/action/xpccheck.py
index c3170a8da8..eec9664a09 100644
--- a/python/mozbuild/mozbuild/action/xpccheck.py
+++ b/python/mozbuild/mozbuild/action/xpccheck.py
@@ -8,7 +8,6 @@ corresponding .ini file.
 Usage: xpccheck.py <directory> [<directory> ...]
 '''
 
-from __future__ import absolute_import
 
 import sys
 import os
@@ -40,7 +39,7 @@ def verifyDirectory(initests, directory):
         break
    
     if not found:
-      print >>sys.stderr, "TEST-UNEXPECTED-FAIL | xpccheck | test %s is missing from test manifest %s!" % (name, os.path.join(directory, 'xpcshell.ini'))
+      print("TEST-UNEXPECTED-FAIL | xpccheck | test {} is missing from test manifest {}!".format(name, os.path.join(directory, 'xpcshell.ini')), file=sys.stderr)
       sys.exit(1)
 
 def verifyIniFile(initests, directory):
@@ -60,12 +59,12 @@ def verifyIniFile(initests, directory):
         break
 
     if not found:
-      print >>sys.stderr, "TEST-UNEXPECTED-FAIL | xpccheck | found %s in xpcshell.ini and not in directory '%s'" % (name, directory)
+      print("TEST-UNEXPECTED-FAIL | xpccheck | found {} in xpcshell.ini and not in directory '{}'".format(name, directory), file=sys.stderr)
       sys.exit(1)
 
 def main(argv):
   if len(argv) < 2:
-    print >>sys.stderr, "Usage: xpccheck.py <topsrcdir> <directory> [<directory> ...]"
+    print("Usage: xpccheck.py <topsrcdir> <directory> [<directory> ...]", file=sys.stderr)
     sys.exit(1)
 
   topsrcdir = argv[0]
diff --git a/python/mozbuild/mozbuild/action/xpidl-process.py b/python/mozbuild/mozbuild/action/xpidl-process.py
index 07ea3cf967..68afa353ac 100755
--- a/python/mozbuild/mozbuild/action/xpidl-process.py
+++ b/python/mozbuild/mozbuild/action/xpidl-process.py
@@ -7,7 +7,6 @@
 # input IDL file(s). It's purpose is to directly support the build
 # system. The API will change to meet the needs of the build system.
 
-from __future__ import absolute_import
 
 import argparse
 import os
@@ -58,7 +57,7 @@ def process(input_dir, inc_paths, cache_dir, header_dir, xpt_dir, deps_dir, modu
 
     # TODO use FileAvoidWrite once it supports binary mode.
     xpt_path = os.path.join(xpt_dir, '%s.xpt' % module)
-    xpt_link(xpts.values()).write(xpt_path)
+    xpt_link(list(xpts.values())).write(xpt_path)
 
     rule.add_targets([xpt_path])
     if deps_dir:
diff --git a/python/mozbuild/mozbuild/action/zip.py b/python/mozbuild/mozbuild/action/zip.py
index 143d7766e6..5e3a63734d 100644
--- a/python/mozbuild/mozbuild/action/zip.py
+++ b/python/mozbuild/mozbuild/action/zip.py
@@ -5,7 +5,6 @@
 # This script creates a zip file, but will also strip any binaries
 # it finds before adding them to the zip.
 
-from __future__ import absolute_import
 
 from mozpack.files import FileFinder
 from mozpack.copier import Jarrer
diff --git a/python/mozbuild/mozbuild/artifacts.py b/python/mozbuild/mozbuild/artifacts.py
index 02538938fb..c72e97fe39 100644
--- a/python/mozbuild/mozbuild/artifacts.py
+++ b/python/mozbuild/mozbuild/artifacts.py
@@ -40,7 +40,6 @@ consumers will need to arrange this themselves.
 '''
 
 
-from __future__ import absolute_import, print_function, unicode_literals
 
 import collections
 import functools
@@ -57,7 +56,7 @@ import stat
 import subprocess
 import tarfile
 import tempfile
-import urlparse
+import urllib.parse
 import zipfile
 
 import pylru
@@ -84,7 +83,6 @@ from mozregression.download_manager import (
 from mozregression.persist_limit import (
     PersistLimit,
 )
-
 NUM_PUSHHEADS_TO_QUERY_PER_PARENT = 50  # Number of candidate pushheads to cache per parent changeset.
 
 # Number of parent changesets to consider as possible pushheads.
@@ -112,7 +110,7 @@ CANDIDATE_TREES = (
     'releases/mozilla-aurora'
 )
 
-class ArtifactJob(object):
+class ArtifactJob:
     # These are a subset of TEST_HARNESS_BINS in testing/mochitest/Makefile.in.
     # Each item is a pair of (pattern, (src_prefix, dest_prefix), where src_prefix
     # is the prefix of the pattern relevant to its location in the archive, and
@@ -183,7 +181,7 @@ class ArtifactJob(object):
 
         with JarWriter(file=processed_filename, optimize=False, compress_level=5) as writer:
             reader = JarReader(filename)
-            for filename, entry in reader.entries.iteritems():
+            for filename, entry in reader.entries.items():
                 for pattern, (src_prefix, dest_prefix) in self.test_artifact_patterns:
                     if not mozpath.match(filename, pattern):
                         continue
@@ -378,7 +376,7 @@ class MacArtifactJob(ArtifactJob):
         finally:
             try:
                 shutil.rmtree(tempdir)
-            except (OSError, IOError):
+            except OSError:
                 self.log(logging.WARN, 'artifact',
                     {'tempdir': tempdir},
                     'Unable to delete {tempdir}')
@@ -442,26 +440,26 @@ JOB_DETAILS = {
                                                   None)),
     'android-x86-opt': (AndroidArtifactJob, ('public/build/target.apk',
                                          None)),
-    'linux-opt': (LinuxArtifactJob, ('public/build/firefox-(.*)\.linux-i686\.tar\.bz2',
-                                     'public/build/firefox-(.*)\.common\.tests\.zip')),
-    'linux-debug': (LinuxArtifactJob, ('public/build/firefox-(.*)\.linux-i686\.tar\.bz2',
-                                 'public/build/firefox-(.*)\.common\.tests\.zip')),
-    'linux64-opt': (LinuxArtifactJob, ('public/build/firefox-(.*)\.linux-x86_64\.tar\.bz2',
-                                       'public/build/firefox-(.*)\.common\.tests\.zip')),
-    'linux64-debug': (LinuxArtifactJob, ('public/build/target\.tar\.bz2',
-                                         'public/build/target\.common\.tests\.zip')),
-    'macosx64-opt': (MacArtifactJob, ('public/build/firefox-(.*)\.mac\.dmg',
-                                      'public/build/firefox-(.*)\.common\.tests\.zip')),
-    'macosx64-debug': (MacArtifactJob, ('public/build/firefox-(.*)\.mac64\.dmg',
-                                  'public/build/firefox-(.*)\.common\.tests\.zip')),
-    'win32-opt': (WinArtifactJob, ('public/build/firefox-(.*)\.win32.zip',
-                                   'public/build/firefox-(.*)\.common\.tests\.zip')),
-    'win32-debug': (WinArtifactJob, ('public/build/firefox-(.*)\.win32.zip',
-                               'public/build/firefox-(.*)\.common\.tests\.zip')),
-    'win64-opt': (WinArtifactJob, ('public/build/firefox-(.*)\.win64.zip',
-                                   'public/build/firefox-(.*)\.common\.tests\.zip')),
-    'win64-debug': (WinArtifactJob, ('public/build/firefox-(.*)\.win64.zip',
-                               'public/build/firefox-(.*)\.common\.tests\.zip')),
+    'linux-opt': (LinuxArtifactJob, (r'public/build/firefox-(.*)\.linux-i686\.tar\.bz2',
+                                     r'public/build/firefox-(.*)\.common\.tests\.zip')),
+    'linux-debug': (LinuxArtifactJob, (r'public/build/firefox-(.*)\.linux-i686\.tar\.bz2',
+                                 r'public/build/firefox-(.*)\.common\.tests\.zip')),
+    'linux64-opt': (LinuxArtifactJob, (r'public/build/firefox-(.*)\.linux-x86_64\.tar\.bz2',
+                                       r'public/build/firefox-(.*)\.common\.tests\.zip')),
+    'linux64-debug': (LinuxArtifactJob, (r'public/build/target\.tar\.bz2',
+                                         r'public/build/target\.common\.tests\.zip')),
+    'macosx64-opt': (MacArtifactJob, (r'public/build/firefox-(.*)\.mac\.dmg',
+                                      r'public/build/firefox-(.*)\.common\.tests\.zip')),
+    'macosx64-debug': (MacArtifactJob, (r'public/build/firefox-(.*)\.mac64\.dmg',
+                                  r'public/build/firefox-(.*)\.common\.tests\.zip')),
+    'win32-opt': (WinArtifactJob, (r'public/build/firefox-(.*)\.win32.zip',
+                                   r'public/build/firefox-(.*)\.common\.tests\.zip')),
+    'win32-debug': (WinArtifactJob, (r'public/build/firefox-(.*)\.win32.zip',
+                               r'public/build/firefox-(.*)\.common\.tests\.zip')),
+    'win64-opt': (WinArtifactJob, (r'public/build/firefox-(.*)\.win64.zip',
+                                   r'public/build/firefox-(.*)\.common\.tests\.zip')),
+    'win64-debug': (WinArtifactJob, (r'public/build/firefox-(.*)\.win64.zip',
+                               r'public/build/firefox-(.*)\.common\.tests\.zip')),
 }
 
 
@@ -492,7 +490,7 @@ def cachedmethod(cachefunc):
     return decorator
 
 
-class CacheManager(object):
+class CacheManager:
     '''Maintain an LRU cache.  Provide simple persistence, including support for
     loading and saving the state using a "with" block.  Allow clearing the cache
     and printing the cache for debugging.
@@ -565,7 +563,7 @@ class CacheManager(object):
         # We use the persisted LRU caches to our advantage.  The first item is
         # most recent.
         with self:
-            item = next(self._cache.items(), None)
+            item = next(list(self._cache.items()), None)
             if item is not None:
                 (name, args, sorted_kwargs), result = item
                 self.print_last_item(args, sorted_kwargs, result)
@@ -593,10 +591,10 @@ class PushheadCache(CacheManager):
                          'changeset={changeset}&version=2&tipsonly=1')
         req = requests.get(cset_url_tmpl.format(tree=tree, changeset=revision),
                            headers={'Accept': 'application/json'})
-        if req.status_code not in range(200, 300):
+        if req.status_code not in list(range(200, 300)):
             raise ValueError
         result = req.json()
-        [found_pushid] = result['pushes'].keys()
+        [found_pushid] = list(result['pushes'].keys())
         return int(found_pushid)
 
     @cachedmethod(operator.attrgetter('_cache'))
@@ -692,7 +690,7 @@ class ArtifactCache(CacheManager):
             self.log(logging.INFO, 'artifact',
                 {'filename': value},
                 'Purged artifact {filename}')
-        except (OSError, IOError):
+        except OSError:
             pass
 
         try:
@@ -700,7 +698,7 @@ class ArtifactCache(CacheManager):
             self.log(logging.INFO, 'artifact',
                 {'filename': value + PROCESSED_SUFFIX},
                 'Purged processed artifact {filename}')
-        except (OSError, IOError):
+        except OSError:
             pass
 
     @cachedmethod(operator.attrgetter('_cache'))
@@ -760,7 +758,7 @@ class ArtifactCache(CacheManager):
             'Last installed binaries from local processed file {filename}')
 
 
-class Artifacts(object):
+class Artifacts:
     '''Maintain state to efficiently fetch build artifacts from a Firefox tree.'''
 
     def __init__(self, tree, substs, defines, job=None, log=None,
@@ -847,7 +845,7 @@ class Artifacts(object):
 
             candidate_pushheads = collections.defaultdict(list)
 
-            for tree, pushid in found_pushids.iteritems():
+            for tree, pushid in found_pushids.items():
                 end = pushid
                 start = pushid - NUM_PUSHHEADS_TO_QUERY_PER_PARENT
 
@@ -1052,7 +1050,7 @@ class Artifacts(object):
         """
         if source and os.path.isfile(source):
             return self.install_from_file(source, distdir)
-        elif source and urlparse.urlparse(source).scheme:
+        elif source and urllib.parse.urlparse(source).scheme:
             return self.install_from_url(source, distdir)
         else:
             if source is None and 'MOZ_ARTIFACT_REVISION' in os.environ:
diff --git a/python/mozbuild/mozbuild/backend/base.py b/python/mozbuild/mozbuild/backend/base.py
index 7ec5fe43d2..bad4e9ab3a 100644
--- a/python/mozbuild/mozbuild/backend/base.py
+++ b/python/mozbuild/mozbuild/backend/base.py
@@ -2,7 +2,6 @@
 # License, v. 2.0. If a copy of the MPL was not distributed with this
 # file, You can obtain one at http://mozilla.org/MPL/2.0/.
 
-from __future__ import absolute_import, unicode_literals
 
 from abc import (
     ABCMeta,
@@ -30,7 +29,7 @@ from .configenvironment import ConfigEnvironment
 from mozbuild.base import ExecutionSummary
 
 
-class BuildBackend(LoggingMixin):
+class BuildBackend(LoggingMixin, metaclass=ABCMeta):
     """Abstract base class for build backends.
 
     A build backend is merely a consumer of the build configuration (the output
@@ -38,8 +37,6 @@ class BuildBackend(LoggingMixin):
     is the discretion of the specific implementation.
     """
 
-    __metaclass__ = ABCMeta
-
     def __init__(self, environment):
         assert isinstance(environment, ConfigEnvironment)
 
@@ -148,12 +145,12 @@ class BuildBackend(LoggingMixin):
         for path in delete_files:
             full_path = mozpath.join(self.environment.topobjdir, path)
             try:
-                with open(full_path, 'r') as existing:
+                with open(full_path) as existing:
                     old_content = existing.read()
                     if old_content:
                         self.file_diffs[full_path] = simple_diff(
                             full_path, old_content.splitlines(), None)
-            except IOError:
+            except OSError:
                 pass
             try:
                 if not self.dry_run:
@@ -162,7 +159,7 @@ class BuildBackend(LoggingMixin):
             except OSError:
                 pass
         # Remove now empty directories
-        for dir in set(mozpath.dirname(d) for d in delete_files):
+        for dir in {mozpath.dirname(d) for d in delete_files}:
             try:
                 os.removedirs(dir)
             except OSError:
@@ -204,7 +201,7 @@ class BuildBackend(LoggingMixin):
         return None
 
     @contextmanager
-    def _write_file(self, path=None, fh=None, mode='rU'):
+    def _write_file(self, path=None, fh=None, mode='r'):
         """Context manager to write a file.
 
         This is a glorified wrapper around FileAvoidWrite with integration to
@@ -252,7 +249,7 @@ class BuildBackend(LoggingMixin):
         srcdir = mozpath.dirname(obj.input_path)
         pp.context.update({
             k: ' '.join(v) if isinstance(v, list) else v
-            for k, v in obj.config.substs.iteritems()
+            for k, v in obj.config.substs.items()
         })
         pp.context.update(
             top_srcdir=obj.topsrcdir,
diff --git a/python/mozbuild/mozbuild/backend/common.py b/python/mozbuild/mozbuild/backend/common.py
index 351c6dbc81..400e3436b9 100644
--- a/python/mozbuild/mozbuild/backend/common.py
+++ b/python/mozbuild/mozbuild/backend/common.py
@@ -2,9 +2,8 @@
 # License, v. 2.0. If a copy of the MPL was not distributed with this
 # file, You can obtain one at http://mozilla.org/MPL/2.0/.
 
-from __future__ import absolute_import, unicode_literals
 
-import cPickle as pickle
+import pickle
 import itertools
 import json
 import os
@@ -50,7 +49,7 @@ from collections import defaultdict
 
 from mozbuild.util import group_unified_files
 
-class XPIDLManager(object):
+class XPIDLManager:
     """Helps manage XPCOM IDLs in the context of the build system."""
     def __init__(self, config):
         self.config = config
@@ -93,7 +92,7 @@ class XPIDLManager(object):
             self.chrome_manifests.add(chrome_manifest)
 
 
-class WebIDLCollection(object):
+class WebIDLCollection:
     """Collects WebIDL info referenced during the build."""
 
     def __init__(self):
@@ -167,7 +166,7 @@ class WebIDLCollection(object):
         return [os.path.splitext(b)[0] for b in self.generated_events_basenames()]
 
 
-class TestManager(object):
+class TestManager:
     """Helps hold state related to tests."""
 
     def __init__(self, config):
@@ -199,7 +198,7 @@ class TestManager(object):
             self.manifest_defaults[sub_manifest] = defaults
 
     def add_installs(self, obj, topsrcdir):
-        for src, (dest, _) in obj.installs.iteritems():
+        for src, (dest, _) in obj.installs.items():
             key = src[len(topsrcdir)+1:]
             self.installs_by_path[key].append((src, dest))
         for src, pat, dest in obj.pattern_installs:
@@ -209,14 +208,14 @@ class TestManager(object):
             self.deferred_installs.add(path[2:])
 
 
-class BinariesCollection(object):
+class BinariesCollection:
     """Tracks state of binaries produced by the build."""
 
     def __init__(self):
         self.shared_libraries = []
         self.programs = []
 
-class IPDLCollection(object):
+class IPDLCollection:
     """Collects IPDL files during the build."""
 
     def __init__(self):
@@ -516,7 +515,7 @@ class CommonBackend(BuildBackend):
                 if '*' not in e.source and not os.path.exists(src.full_path):
                     if e.is_locale:
                         raise Exception(
-                            '%s: Cannot find %s' % (obj.path, e.source))
+                            '{}: Cannot find {}'.format(obj.path, e.source))
                     if e.source.startswith('/'):
                         src = Path(jar_context, '!' + e.source)
                     else:
diff --git a/python/mozbuild/mozbuild/backend/configenvironment.py b/python/mozbuild/mozbuild/backend/configenvironment.py
index 0edcf53660..737320855d 100644
--- a/python/mozbuild/mozbuild/backend/configenvironment.py
+++ b/python/mozbuild/mozbuild/backend/configenvironment.py
@@ -2,13 +2,13 @@
 # License, v. 2.0. If a copy of the MPL was not distributed with this
 # file, You can obtain one at http://mozilla.org/MPL/2.0/.
 
-from __future__ import absolute_import
 
 import os
 import sys
 
-from collections import Iterable
-from types import StringTypes, ModuleType
+from collections.abc import Iterable
+from types import ModuleType
+StringTypes = (str,)
 
 import mozpack.path as mozpath
 
@@ -16,13 +16,10 @@ from mozbuild.util import ReadOnlyDict
 from mozbuild.shellutil import quote as shell_quote
 
 
-if sys.version_info.major == 2:
-    text_type = unicode
-else:
-    text_type = str
+text_type = str
 
 
-class BuildConfig(object):
+class BuildConfig:
     """Represents the output of configure."""
 
     _CODE_CACHE = {}
@@ -51,7 +48,7 @@ class BuildConfig(object):
             mod.__file__ = path
             sys.modules['config.status'] = mod
 
-            with open(path, 'rt') as fh:
+            with open(path) as fh:
                 source = fh.read()
                 code_cache[path] = (
                     mtime,
@@ -73,7 +70,7 @@ class BuildConfig(object):
         return config
 
 
-class ConfigEnvironment(object):
+class ConfigEnvironment:
     """Perform actions associated with a configured but bare objdir.
 
     The purpose of this class is to preprocess files from the source directory
@@ -118,12 +115,18 @@ class ConfigEnvironment(object):
         if not source:
             source = mozpath.join(topobjdir, 'config.status')
         self.source = source
-        self.defines = ReadOnlyDict(defines or {})
-        self.non_global_defines = non_global_defines or []
-        self.substs = dict(substs or {})
-        self.topsrcdir = mozpath.abspath(topsrcdir)
-        self.topobjdir = mozpath.abspath(topobjdir)
-        self.mozconfig = mozpath.abspath(mozconfig) if mozconfig else None
+        def _decode(v):
+            if isinstance(v, bytes):
+                return v.decode('utf-8')
+            if isinstance(v, list):
+                return [_decode(i) for i in v]
+            return v
+        self.defines = ReadOnlyDict({_decode(k): _decode(v) for k, v in (defines or {}).items()})
+        self.non_global_defines = [_decode(x) for x in (non_global_defines or [])]
+        self.substs = {_decode(k): _decode(v) for k, v in (substs or {}).items()}
+        self.topsrcdir = mozpath.abspath(_decode(topsrcdir))
+        self.topobjdir = mozpath.abspath(_decode(topobjdir))
+        self.mozconfig = mozpath.abspath(_decode(mozconfig)) if mozconfig else None
         self.lib_prefix = self.substs.get('LIB_PREFIX', '')
         if 'LIB_SUFFIX' in self.substs:
             self.lib_suffix = '.%s' % self.substs['LIB_SUFFIX']
@@ -138,16 +141,18 @@ class ConfigEnvironment(object):
 
         global_defines = [name for name in self.defines
             if not name in self.non_global_defines]
-        self.substs['ACDEFINES'] = ' '.join(['-D%s=%s' % (name,
+        self.substs['ACDEFINES'] = ' '.join(['-D{}={}'.format(name,
             shell_quote(self.defines[name]).replace('$', '$$'))
             for name in sorted(global_defines)])
         def serialize(obj):
+            if isinstance(obj, bytes):
+                return obj.decode('utf-8')
             if isinstance(obj, StringTypes):
                 return obj
             if isinstance(obj, Iterable):
-                return ' '.join(obj)
+                return ' '.join(item.decode('utf-8') if isinstance(item, bytes) else item for item in obj)
             raise Exception('Unhandled type %s', type(obj))
-        self.substs['ALLSUBSTS'] = '\n'.join(sorted(['%s = %s' % (name,
+        self.substs['ALLSUBSTS'] = '\n'.join(sorted(['{} = {}'.format(name,
             serialize(self.substs[name])) for name in self.substs if self.substs[name]]))
         self.substs['ALLEMPTYSUBSTS'] = '\n'.join(sorted(['%s =' % name
             for name in self.substs if not self.substs[name]]))
diff --git a/python/mozbuild/mozbuild/backend/fastermake.py b/python/mozbuild/mozbuild/backend/fastermake.py
index 0ca385187b..af3f27b0f2 100644
--- a/python/mozbuild/mozbuild/backend/fastermake.py
+++ b/python/mozbuild/mozbuild/backend/fastermake.py
@@ -2,7 +2,6 @@
 # License, v. 2.0. If a copy of the MPL was not distributed with this
 # file, You can obtain one at http://mozilla.org/MPL/2.0/.
 
-from __future__ import absolute_import, unicode_literals, print_function
 
 from mozbuild.backend.base import PartialBackend
 from mozbuild.backend.common import CommonBackend
@@ -24,7 +23,7 @@ import mozpack.path as mozpath
 
 class FasterMakeBackend(CommonBackend, PartialBackend):
     def _init(self):
-        super(FasterMakeBackend, self)._init()
+        super()._init()
 
         self._manifest_entries = OrderedDefaultDict(set)
 
@@ -128,14 +127,14 @@ class FasterMakeBackend(CommonBackend, PartialBackend):
         ):
             value = self.environment.substs.get(var)
             if value is not None:
-                mk.add_statement('%s = %s' % (var, value))
+                mk.add_statement('{} = {}'.format(var, value))
 
-        install_manifests_bases = self._install_manifests.keys()
+        install_manifests_bases = list(self._install_manifests.keys())
 
         # Add information for chrome manifest generation
         manifest_targets = []
 
-        for target, entries in self._manifest_entries.iteritems():
+        for target, entries in self._manifest_entries.items():
             manifest_targets.append(target)
             install_target = mozpath.basedir(target, install_manifests_bases)
             self._install_manifests[install_target].add_content(
@@ -144,16 +143,16 @@ class FasterMakeBackend(CommonBackend, PartialBackend):
 
         # Add information for install manifests.
         mk.add_statement('INSTALL_MANIFESTS = %s'
-                         % ' '.join(self._install_manifests.keys()))
+                         % ' '.join(list(self._install_manifests.keys())))
 
         # Add dependencies we infered:
-        for target, deps in self._dependencies.iteritems():
+        for target, deps in self._dependencies.items():
             mk.create_rule([target]).add_dependencies(
                 '$(TOPOBJDIR)/%s' % d for d in deps)
 
         mk.add_statement('include $(TOPSRCDIR)/config/faster/rules.mk')
 
-        for base, install_manifest in self._install_manifests.iteritems():
+        for base, install_manifest in self._install_manifests.items():
             with self._write_file(
                     mozpath.join(self.environment.topobjdir, 'faster',
                                  'install_%s' % base.replace('/', '_'))) as fh:
